defmodule Authex.Blacklist.Basic do
  use Agent
  use Authex.Blacklist

  def start_link do
    Agent.start_link(fn -> MapSet.new() end, name: __MODULE__)
  end

  def handle_get(jti) do
    __MODULE__
    |> Agent.get(&(&1))
    |> MapSet.member?(jti)
  end

  def handle_set(jti) do
    Agent.update(__MODULE__, &MapSet.put(&1, jti))
    :ok
  end

  def handle_del(jti) do
    Agent.update(__MODULE__, &MapSet.delete(&1, jti))
    :ok
  end
end
